<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
  <link rel="stylesheet" href="https://cdn.datatables.net/1.13.5/css/jquery.dataTables.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <script src="https://cdn.datatables.net/1.13.5/js/jquery.dataTables.min.js"></script>
  <script>
    "use strict";
    /* Mảng userObjects là mảng chứa dữ liệu user. Từng phần tử là object
    */
   
  var gStudents = [
    {
      id: 2,
      studentCode: "1356783",
      firstname: "Ngo Van",
      lastname: "Quan",
      age: 18,
      email: "quan@gmail.com",
      studyYear: 2015
    },
    // Thêm 4 sinh viên nữa
    {
      id: 3,
      studentCode: "1356784",
      firstname: "Nguyen Thi",
      lastname: "Anh",
      age: 20,
      email: "anh@gmail.com",
      studyYear: 2016
    },
    {
      id: 4,
      studentCode: "1356785",
      firstname: "Tran Van",
      lastname: "Huy",
      age: 22,
      email: "huy@gmail.com",
      studyYear: 2017
    },
    {
      id: 5,
      studentCode: "1356786",
      firstname: "Le Thi",
      lastname: "Mai",
      age: 19,
      email: "mai@gmail.com",
      studyYear: 2015
    },
    {
      id: 6,
      studentCode: "1356787",
      firstname: "Pham Van",
      lastname: "Trung",
      age: 21,
      email: "trung@gmail.com",
      studyYear: 2018
    }
  ];

  var gSubjects = [
    {
      id: 5,
      subjectCode: "MATH101",
      subjectName: "Toán cao cấp 1"
    },
    // Thêm 4 môn học nữa
    {
      id: 6,
      subjectCode: "ENG102",
      subjectName: "English for Communication"
    },
    {
      id: 7,
      subjectCode: "PHYS103",
      subjectName: "Physics Basics"
    },
    {
      id: 8,
      subjectCode: "CHEM104",
      subjectName: "Chemistry Fundamentals"
    },
    {
      id: 9,
      subjectCode: "BIO105",
      subjectName: "Biology Intro"
    }
  ];

  var gGrades = [
    {
      id: 2,
      studentId: 2,
      subjectId: 5,
      grade: 8,
      examDate: "13/04/2021"
    },
    // Thêm 9 kết quả học tập nữa
    {
      id: 3,
      studentId: 2,
      subjectId: 6,
      grade: 9.5,
      examDate: "20/05/2021"
    },
    {
      id: 4,
      studentId: 3,
      subjectId: 5,
      grade: 7.5,
      examDate: "18/04/2021"
    },
    {
      id: 5,
      studentId: 3,
      subjectId: 7,
      grade: 6.8,
      examDate: "25/05/2021"
    },
    {
      id: 6,
      studentId: 4,
      subjectId: 5,
      grade: 6.3,
      examDate: "10/04/2021"
    },
    {
      id: 7,
      studentId: 4,
      subjectId: 8,
      grade: 8.7,
      examDate: "22/05/2021"
    },
    {
      id: 8,
      studentId: 5,
      subjectId: 5,
      grade: 9.1,
      examDate: "14/04/2021"
    },
    {
      id: 9,
      studentId: 5,
      subjectId: 9,
      grade: 7.2,
      examDate: "27/05/2021"
    },
    {
      id: 10,
      studentId: 6,
      subjectId: 5,
      grade: 8.8,
      examDate: "15/04/2021"
    },
    {
      id: 11,
      studentId: 6,
      subjectId: 6,
      grade: 7.9,
      examDate: "23/05/2021"
    }
  ];

  console.log("gStudents =", gStudents);
  console.log("gSubjects =", gSubjects);
  console.log("gGrades =", gGrades);
  var dataTable;
  var filteredGrades = []
  function loadDataTable(data) {
      dataTable = $('#order-table').DataTable({
        data: data,
        columns: [
          { data: 'id' },
          { 
            data: 'students', 
            render: function (data, type, row) {
              // Get the corresponding student object from gStudents array based on studentId
              var student = gStudents.find(function (student) {
                return student.id === row.studentId;
              });

              // Return the formatted student's full name
              return student ? (student.firstname + ' ' + student.lastname) : '';
            }
          },
          { 
            data: 'subjectId', 
            render: function (data, type, row) {
              // Get the corresponding subject object from gSubjects array based on subjectId
              var subject = gSubjects.find(function (subject) {
                return subject.id === data;
              });

              // Return the subjectName
              return subject ? subject.subjectName : '';
            }
          },
          { data: 'grade' },
          { data: 'examDate' }
        ]
      });
    }


    // Function to load data into select options
    function loadSelectOptions(data, selectId, textKeys, valueKey) {
      var selectElement = $('#' + selectId);
      selectElement.empty();
      $.each(data, function (index, item) {
        var textValue = '';
        if (Array.isArray(textKeys)) {
          for (var i = 0; i < textKeys.length; i++) {
            textValue += item[textKeys[i]] + ' ';
          }
        } else {
          textValue = item[textKeys];
        }
        textValue = textValue.trim(); // Remove extra space from the end
        selectElement.append($('<option>', {
          text: textValue,
          value: item[valueKey]
        }));
      });
    }
    $(document).ready(function () {
      loadDataTable(gGrades);
      loadSelectOptions(gStudents, 'studentSelect', ['firstname','lastname'], 'id');
      loadSelectOptions(gSubjects, 'subjectSelect', 'subjectName', 'id');

      $('#btn-filter-order').on('click', function () {
        var studentId = $('#studentSelect').val();
        var subjectId = $('#subjectSelect').val();

        // Update the filteredGrades variable with the filtered data
        filteredGrades = gGrades.filter(function (grade) {
          return (studentId === '' || grade.studentId.toString() === studentId) &&
                 (subjectId === '' || grade.subjectId.toString() === subjectId);
        });

        // Clear the existing data and add the filtered data to the table
        dataTable.clear();
        dataTable.rows.add(filteredGrades);
        dataTable.draw();
      });
    });
  </script>
</head>

<body>
  <div class="container">
    <div class="form-group">
      <pre>
        - Định nghĩa 03 đối tượng students (sinh viên), subjects (môn học) và grades (bảng điểm)
        - Điền dữ liệu mẫu cho 03 đối tượng trên. 
            + Student điền 5 sinh viên
            + Subject điền 5 môn học
            + Grades: điền 10 kết quả học tập cho các sinh viên và môn học ở trên
        - Thực hiện load dữ liệu bảng điểm (grades)
        - Thêm bộ lọc theo 2 ô select: Student và Subject
      </pre>
      <div class="container">
        <div class="text-center mt-2 mb-2">
          <h2>F120 - Quản trị Order</h2>
        </div>
        <div class="jumbotron container ">
          <div class="row form-group ">
            <div class="col-sm-3 text-center">
              <label for="studentSelect">Student</label>
            </div>
            <div class="col-sm-3">
              <select id="studentSelect" class="form-control">
                <!-- Add options for students here -->
              </select>
            </div>
            <div class="col-sm-3 text-center">
              <label for="subjectSelect">Subject</label>
            </div>
            <div class="col-sm-3">
              <select id="subjectSelect" class="form-control">
                <!-- Add options for subjects here -->
              </select>
            </div>
            <div class="col-sm-3">
              <button id="btn-filter-order" class="btn btn-info">Lọc dữ liệu</button>
            </div>
          </div>
        </div>
      
      <div class="container">
        <table class="table table-bordered table-striped table-hover" id="order-table">
          <thead>
            <tr>
              <th>STT</th>
              <th>Student</th>
              <th>Môn học</th>
              <th>Điểm</th>
              <th>Ngày thi</th>
            </tr>
          </thead>
        </table>
      </div>
    </div>
  </div>
</body>

</html>